; # This is (hopefully) a demonstration of how pathetically easy it is to script
; # a neato effect you've come up with.  This lil' effect was created by xach,
; # and translated by sjburges (me).  You can consider it released under the GPL
; # or Artistic liscence, whichever makes you happier.
; #
; # <Xach> sjburges: 1. pixelize the photo  2. in a new white layer, render a grid
; #           at the same resolution as the pixelize, then blur it. threshold the 
; #           grid until you get a roundish blob in the center of each square (you
; #           may need to repeat a few times).
; # <Xach> sjburges: meanwhile, back at the pixelized image, bumpmap it with 
; #           itself and a depth of about 5. do this twice. then bumpmap it with 
; #           the round blobby layer.
; # <Xach> then create a new, clean grid, and bumpmap the pixelized layer with it
; #
; 
; # (To get a decent blobby grid)
; # <Xach> <Xach> render a grid at 10x10, gaussian blur at 7, then set levels to 
; #           196 1.00 234                                                    
; 
; # Revision - 1.1:  	added a gimp_displays_flush() for 1.0.x users
; #            		stopped deleting the layers after removal - it was
; #                   causing bad things to happen with refcounts.  I hope
; #                   gimp is cleaning up this memory on its own...
; #            1.2:   Fixed buggy selection handling - oops ;)  
; #            1.3:   Added undo capability by Marc Lehman <pcg@goof.com>
; #            1.4:   Marc Lehman <pcg@goof.com>, changed function name
; #            1.5:   Seth Burgess <sjburges@gimp.org> added my email, put it
; #                   in a directory more suitable than the lame "Misc"
; # Here's the boring start of every script...
; 
; The original Perl-Fu script was written by Seth Burgess
; See gimp/plug-ins/perl/examples/* in source archives
; 
; Translated into Script-Fu by Iccii <iccii@hotmail.com>
;
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/12/02
;     - Initial relase
;
; --------------------------------------------------------------------

(define (script-fu-perl-xach-blocks
			img drawable gridari? knobari? blocksize knobfactor)
(let* ((image-width (car (gimp-drawable-width drawable)))
       (image-height (car (gimp-drawable-height drawable))))

	(gimp-undo-push-group-start img)
	(set! selection-flag 0)
	(if (not (equal? (car (gimp-drawable-has-alpha drawable)) TRUE))
	    (gimp-layer-add-alpha drawable))
	(if (equal? (car (gimp-selection-is-empty img)) TRUE)
	    (begin
	      (gimp-selection-all img)
	      (set! selection-flag 1)))
	(set! oldbackground (car (gimp-palette-get-background)))
; # Now the fun begins :)

	(set! selection (car (gimp-selection-save img)))

; #1. Pixelize the photo
	(plug-in-pixelize 1 img drawable blocksize) 
; # 2. in a new white layer, render a grid
; #           at the same resolution as the pixelize, then blur it.
	(set! gridlayer (car (gimp-layer-new img image-width image-height
	                                     RGBA_IMAGE "Grid 1" 100 0)))

	(gimp-image-add-layer img gridlayer 0)
	(gimp-selection-all img)
	(gimp-edit-clear gridlayer)
	(gimp-palette-set-background '(255 255 255))
	(gimp-edit-fill gridlayer BG-IMAGE-FILL)
	(plug-in-grid 1 img gridlayer 1 blocksize 0 '(0 0 0) 255
	              1 blocksize 0 '(0 0 0) 255 0 0 0 '(0 0 0) 0)
	(plug-in-gauss-iir 1 img gridlayer (* 0.7 blocksize) 1 1)

; #	threshold the 
; #   grid until you get a roundish blob in the center of each square (you
; #   may need to repeat a few times).	

        (if (= knobari? TRUE)
	(gimp-levels gridlayer 0 195 234 (/ knobfactor 100.0) 0 255))

; # <Xach> sjburges: meanwhile, back at the pixelized image, bumpmap it with 
; #           itself and a depth of about 5. do this twice.  
	(gimp-selection-load selection)
	(plug-in-bump-map 1 img drawable drawable 135 45 5 0 0 0 0 1 0 0)
	(plug-in-bump-map 1 img drawable drawable 135 45 5 0 0 0 0 1 0 0)
	(plug-in-bump-map 1 img drawable gridlayer 135 45 5 0 0 0 0 1 0 0)
 
; # <Xach> then create a new, clean grid, and bumpmap the pixelized layer with it
	(gimp-selection-all img)
	(set! cleangrid (car (gimp-layer-new img image-width image-height
	                                     RGBA_IMAGE "Grid 2" 100 0)))
(if (= gridari? TRUE)
(begin
	(gimp-image-add-layer img cleangrid 0)
	(gimp-edit-fill cleangrid BG-IMAGE-FILL)
	(plug-in-grid 1 img cleangrid 1 blocksize 0 '(0 0 0) 255
	              1 blocksize 0 '(0 0 0) 255 0 0 0 '(0 0 0) 0)
	(gimp-selection-load selection)
	(plug-in-bump-map 1 img drawable cleangrid 135 45 3 0 0 0 0 1 0 0)
	(gimp-selection-all img)
))

; # Clean up stuff

	(gimp-image-remove-layer img cleangrid)
; #	$cleangrid->delete;  # Deleting these layers after removal seems to cause
;                          # strange problems (I think gimp handles this 
;                          # automatically now)
	(gimp-image-remove-layer img gridlayer)
; #	$gridlayer->delete;
	(gimp-selection-load selection)
	(gimp-palette-set-background oldbackground)
	(if (= selection-flag 1)
	    (gimp-selection-none img))
	(gimp-undo-push-group-end img)
	(gimp-displays-flush)

)
);let
(script-fu-register
  "script-fu-perl-xach-blocks"
  "<Image>/Script-Fu/Filters/Xach Blocks..."
  "Xach's Blocks o' Fun"
  "Seth Burgess"
  "Seth Burgess <sjburges@gimp.org>"
  "2-15-98"
  "RGB*"
  SF-IMAGE      "Image"       0
  SF-DRAWABLE   "Drawable"    0
  SF-TOGGLE     "Grid"        TRUE
  SF-TOGGLE     "Knob"        TRUE
  SF-ADJUSTMENT "Block Size"  '(10 2 255 1 1 0 0)
  SF-ADJUSTMENT "Knob Factor" '(40 10 100 5 5 0 0)
)
